// použitý čip: ATmega328
#include <EEPROM.h>
#include <Wire.h>
#include <DS3231.h>
#include <LiquidCrystal_I2C.h>
// *************************************************instance z knihoven
DS3231 clock;
RTCDateTime datumCas;
LiquidCrystal_I2C lcd(0x27,16,2);
//**************************************************DEKLARACE PROMĚNNÝCH
int hodZap,minZap,hodVyp,minVyp,hod,minut;
int hodZap2,minZap2,hodVyp2,minVyp2,hodZap3,minZap3,hodVyp3,minVyp3;
int strana=0,radek=0,OnOff,OnOff2,OnOff3;
#define dobaPodsvitu 20000// doba podsvícení LCD nastavena na 20 sekund
#define CasStisk 300
#define dobaNecinnosti 60000
boolean NastaveniCasu=false,state=false,state2=false,state3=false,stavTecka,blik,podsvit=0;  
unsigned long Casomira, millisPodsvit,refresh,dvojtecka;
int rozdil;
int info=0;
int obnovaDat,obnovitData;
unsigned long millisBlik,necinnost;
// ************************************************Nastavení GPIO pinů

#define enter 2
#define plus 3
#define minus 4
#define MENU 5
#define vystup 6
#define vystup2 7
#define vystup3 8
#define kontrolka 13

void setup() {
  // vytvoření vlastních znaků
byte Smajlik[] = {B00000,B00000,B01010,B00000,B00100,B10001,B01110,B00000,};
byte Smutnik[] = {B00000,B00000,B01010,B00000,B00100,B00000,B01110,B10001,};
byte hodiny []={B00000,B00000,B00000,B01110,B10101,B10111,B10001,B01110,};
byte maleC[] = {B01010,B00100,B01110,B10000,B10000,B10001,B01110,B00000,};
byte dlouheA[] = {B00010,B00100,B01110,B00001,B01111,B10001,B01111,B00000,};
byte dlouheI[] = {B00001,B00010,B01100,B00100,B00100,B00100,B01110,B00000};

lcd.init();
// iniciace vlastních symbolů
lcd.createChar(0,Smajlik);
lcd.createChar(1,Smutnik);
lcd.createChar(2,hodiny);
lcd.createChar(3,dlouheA);
lcd.createChar(4,maleC);
lcd.createChar(5,dlouheI);
lcd.createChar(6,Smutnik);
//iniciace výstupů

  pinMode(plus,INPUT);
  pinMode(minus,INPUT);
  pinMode(enter,INPUT);
  pinMode(MENU,INPUT);
  pinMode(vystup,OUTPUT);
  pinMode(vystup2,OUTPUT);
  pinMode(vystup3,OUTPUT);
  pinMode(kontrolka,OUTPUT);

for(uint8_t e=0;e<12;e++){
  EEPROM.read(e);
  if (EEPROM.read(e)==255){EEPROM.update(e,0);}
}
for(uint8_t e=20;e<23;e++){
  EEPROM.read(e);
  if (EEPROM.read(e)==255){EEPROM.update(e,1);}
}

    
//načtení uložených hodnot z EEPROM pamětí
refreshEEPROM();

  // programové nastavení času ve formátu - SW nastavení - pro nastavení přes PC - změnit hod a min za čísla
  //clock.setDateTime(rok, mes, den, hod, minut, sekundy);
 lcd.clear();
lcd.backlight();
podsvit=1;

millisPodsvit=millis();}

void loop() {

while (isRunning(0x68)==false){
   lcd.setCursor(0,0);
   lcd.print(" RTC NENALEZEN  ");
   lcd.setCursor(0,1);
   lcd.print("      ");
   lcd.write(1);
   lcd.print("      ");
   digitalWrite(vystup,LOW);digitalWrite(vystup2,LOW);digitalWrite(vystup3,LOW);
   blikani(kontrolka);}

  
   datumCas = clock.getDateTime();
 
   if ((digitalRead(MENU))||(digitalRead(enter))||(digitalRead(plus))||(digitalRead(minus))) {podsvit=1;millisPodsvit=millis();refresh=millis();}
  Casomira=millis();

// stisk tlačítka MENU
while(digitalRead(MENU)) {rozdil = millis()- Casomira;}
if (rozdil>=25)  {refreshEEPROM();info=1;rozdil=0;lcd.clear();}

if (info>7) info = 0;
if (info<0) info=7;
  //zobrazení informací na LCD
switch(info){
  case 0:hodinyCas();break;
  case 1: Menu();break;
  case 2: NastaveniRTC();break;
  case 3: Kanal1();break;
  case 4: Kanal2();break;
  case 5: Kanal3();break;
  case 6: Teplota();break;
  case 7: Obnov();break;
  }
  if (podsvit==0) lcd.noBacklight();
  else if (podsvit==1) {lcd.backlight(); if (millis()-millisPodsvit>dobaPodsvitu) {podsvit=0;}}

  digitalWrite(kontrolka,(state==1||state2==1||state3==1)?1:0);
  
// vyčištění obrazovky kvůli případným rušivým znakům způsobeným elektromag. rušením
if ((millis()-refresh)>dobaNecinnosti){refresh=millis();lcd.clear();radek=0;info=0;refreshEEPROM();}


 
  if ((OnOff && OnOff2 && OnOff3)== 1) {digitalWrite(vystup,LOW);digitalWrite(vystup2,LOW);digitalWrite(vystup3,LOW);state=false;state2=false;state3=false;}
  if (OnOff==1){digitalWrite(vystup,LOW);state=false;}
  if (OnOff2==1){digitalWrite(vystup2,LOW);state2=false;}
  if (OnOff3==1){digitalWrite(vystup3,LOW);state3=false;}
  
  if (OnOff==0){
//********************************************************************************************************************************************************SPÍNAČ KANÁL 1
  if (hodZap < hodVyp){
  if (datumCas.hour >= hodZap && datumCas.minute>=minZap)
  {digitalWrite(vystup,HIGH);state=true; }//---------------------------------------------------Podmínka pro sepnutí spínacích hodin
   if (datumCas.hour >= hodVyp && datumCas.minute >= minZap) 
  {digitalWrite(vystup,LOW);state=false;}
  else if (datumCas.hour >= hodVyp && datumCas.minute>=minVyp)
  {digitalWrite(vystup,LOW);state=false;}}//----------------------------------------------------Podmínka pro vypnutí spínacích hodin

   if (hodZap > hodVyp){
  if (datumCas.hour >= hodZap && datumCas.minute>=minZap && datumCas.hour <=23)
  {digitalWrite(vystup,HIGH);state=true; }//---------------------------------------------------Podmínka pro sepnutí spínacích hodin
  else if (datumCas.hour < hodVyp)
  {digitalWrite(vystup,HIGH);state=true; }
  else if (datumCas.hour >= hodVyp && datumCas.minute >= minVyp && datumCas.hour < hodZap){digitalWrite(vystup,LOW);state=false;}}

   if (hodZap == hodVyp){
    if (datumCas.hour == hodZap && datumCas.minute>=minZap)
  {digitalWrite(vystup,HIGH);state=true; }//---------------------------------------------------Podmínka pro sepnutí spínacích hodin
  if (datumCas.hour == hodVyp && datumCas.minute>=minVyp)
  {digitalWrite(vystup,LOW);state=false;}}//----------------------------------------------------Podmínka pro vypnutí spínacích hodin
  }
//*****************************************************************************************************************************************************Spínač KANÁL 2
  if (OnOff2==0){
  if (hodZap2 < hodVyp2){
  if (datumCas.hour >= hodZap2 && datumCas.minute>=minZap2)
  {digitalWrite(vystup2,HIGH);state2=true; }//---------------------------------------------------Podmínka pro sepnutí spínacích hodin2
   if (datumCas.hour >= hodVyp2 && datumCas.minute >= minZap2){digitalWrite(vystup2,LOW);state2=false;} 
  else if (datumCas.hour >= hodVyp2 && datumCas.minute>=minVyp2)
  {digitalWrite(vystup2,LOW);state2=false;}}//----------------------------------------------------Podmínka pro vypnutí spínacích hodin2

   if (hodZap2 > hodVyp2){
  if (datumCas.hour >= hodZap2 && datumCas.minute>=minZap2 && datumCas.hour <=23)
  {digitalWrite(vystup2,HIGH);state2=true; }//---------------------------------------------------Podmínka pro sepnutí spínacích hodin2
  else if (datumCas.hour < hodVyp2) 
  {digitalWrite(vystup2,HIGH);state2=true; }
  else if (datumCas.hour >= hodVyp2 && datumCas.minute >= minVyp2 && datumCas.hour < hodZap2){digitalWrite(vystup2,LOW);state2=false;}}

  if (hodZap2 == hodVyp2){
    if (datumCas.hour == hodZap2 && datumCas.minute>=minZap2)
  {digitalWrite(vystup2,HIGH);state2=true; }//---------------------------------------------------Podmínka pro sepnutí spínacích hodin2
  if (datumCas.hour == hodVyp2 && datumCas.minute>=minVyp2)
  {digitalWrite(vystup2,LOW);state2=false;}}}//----------------------------------------------------Podmínka pro vypnutí spínacích hodin2

  //*****************************************************************************************************************************************************SPÍNAČ KANÁL 3
  if (OnOff3==0){
   if (hodZap3 < hodVyp3){
  if (datumCas.hour >= hodZap3 && datumCas.minute>=minZap3)
  {digitalWrite(vystup3,HIGH);state3=true; }//---------------------------------------------------Podmínka pro sepnutí spínacích hodin3
   if (datumCas.hour >= hodVyp3 && datumCas.minute >= minZap3) {digitalWrite(vystup3,LOW);state3=false;}
  else if (datumCas.hour >= hodVyp3 && datumCas.minute>=minVyp3)
  {digitalWrite(vystup3,LOW);state3=false;}}//----------------------------------------------------Podmínka pro vypnutí spínacích hodin3

   if (hodZap3 > hodVyp3){
  if (datumCas.hour >= hodZap3 && datumCas.minute>=minZap3 && datumCas.hour <=23)
  {digitalWrite(vystup3,HIGH); state3=true;}//---------------------------------------------------Podmínka pro sepnutí spínacích hodin3
  else if (datumCas.hour < hodVyp3)
  {digitalWrite(vystup3,HIGH);state3=true; }
  else if (datumCas.hour >= hodVyp3 && datumCas.minute >= minVyp3 && datumCas.hour < hodZap2){digitalWrite(vystup3,LOW);state3=false;}}
  
   if (hodZap3 == hodVyp3){
    if (datumCas.hour == hodZap3 && datumCas.minute>=minZap3)
  {digitalWrite(vystup3,HIGH); state3=true;}//---------------------------------------------------Podmínka pro sepnutí spínacích hodin3
  if (datumCas.hour == hodVyp3 && datumCas.minute>=minVyp3)
  {digitalWrite(vystup3,LOW); state3=false;}}}//----------------------------------------------------Podmínka pro vypnutí spínacích hodin3
}
